(set-info :smt-lib-version 2.6)
(set-logic UFNIA)
(declare-sort Prog1 0)
(declare-fun ZERO () Prog1)
(declare-fun ONE () Prog1)
(declare-fun TWO () Prog1)
(declare-fun ADDI (Prog1 Prog1) Prog1)
(declare-fun DIFF (Prog1 Prog1) Prog1)
(declare-fun MULT (Prog1 Prog1) Prog1)
(declare-fun DIVI (Prog1 Prog1) Prog1)
(declare-fun MODU (Prog1 Prog1) Prog1)
(declare-fun COND (Prog1 Prog1 Prog1) Prog1)
(declare-fun LOOP (Prog1 Prog1 Prog1) Prog1)
(declare-fun X () Prog1)
(declare-fun Y () Prog1)
(declare-fun ev1 (Prog1 Int Int) Int)
(assert (forall ((m Int) (n Int)) (= (ev1 ZERO m n) 0)))
(assert (forall ((m Int) (n Int)) (= (ev1 ONE m n) 1)))
(assert (forall ((m Int) (n Int)) (= (ev1 TWO m n) 2)))
(assert (forall ((m Int) (n Int)) (= (ev1 X m n) m)))
(assert (forall ((m Int) (n Int)) (= (ev1 Y m n) n)))
(assert (forall ((p Prog1) (q Prog1) (m Int) (n Int)) (= (ev1 (ADDI p q) m n) (+ (ev1 p m n) (ev1 q m n)))))
(assert (forall ((p Prog1) (q Prog1) (m Int) (n Int)) (= (ev1 (DIFF p q) m n) (- (ev1 p m n) (ev1 q m n)))))
(assert (forall ((p Prog1) (q Prog1) (m Int) (n Int)) (= (ev1 (MULT p q) m n) (* (ev1 p m n) (ev1 q m n)))))
(assert (forall ((p Prog1) (q Prog1) (m Int) (n Int)) (= (ev1 (DIVI p q) m n) (div (ev1 p m n) (ev1 q m n)))))
(assert (forall ((p Prog1) (q Prog1) (m Int) (n Int)) (= (ev1 (MODU p q) m n) (mod (ev1 p m n) (ev1 q m n)))))
(assert (forall ((p Prog1) (q Prog1) (r Prog1) (m Int) (n Int)) (=> (<= (ev1 p m n) 0) (= (ev1 (COND p q r) m n) (ev1 q m n)))))
(assert (forall ((p Prog1) (q Prog1) (r Prog1) (m Int) (n Int)) (=> (> (ev1 p m n) 0) (= (ev1 (COND p q r) m n) (ev1 r m n)))))
(assert (forall ((p Prog1) (q Prog1) (r Prog1) (m Int) (n Int)) (=> (<= (ev1 q m n) 0) (= (ev1 (LOOP p q r) m n) (ev1 r m n)))))
(assert (forall ((p Prog1) (q Prog1) (r Prog1) (m Int) (n Int)) (=> (> (ev1 q m n) 0) (= (ev1 (LOOP p q r) m n) (ev1 p (ev1 (LOOP p (DIFF q ONE) r) m n) m)))))
(assert (not (forall ((n Int)) (= (ev1 (DIVI TWO (COND X TWO X)) n 0) (ev1 (DIVI
                                                                            TWO
                                                                            (LOOP Y X TWO)) n 0)))))
(check-sat)
